<template>
  <div class="sticky sticky_zindex" :class="{ 'sticky-show': isSticky }">
    <header id="header" class="setcion sticky header header-mobile">
      <div class="btn_control_menu">
        <svg-icon name="hamburger"></svg-icon>
      </div>
      <nuxt-link class="img_logo" to="/">
        <img src="/css/images/graphics/logo.svg" alt="thinkpro" />
      </nuxt-link>
      <div class="header__right">
        <button id="auto_search_button">
          <svg-icon name="search"></svg-icon>
        </button>
        <a class="close-search">
          <svg-icon name="close"></svg-icon>
        </a>
        <div class="block_search section">
          <div id="search" class="search" @submit.prevent>
            <input
              v-model="search"
              class="fs-stxt onclick-togle search-input"
              type="text"
              placeholder="Tìm kiếm trên ThinkPro"
              autocomplete="on"
              maxlength="50"
              @keyup.enter.prevent="searchIt"
            />
            <button class="search-button" @click.prevent="searchIt">
              <svg-icon name="search"></svg-icon>
            </button>
          </div>
        </div>

        <div class="gio-hang">
          <a id="cart-mobile" href="javascript:;" class="onclick">
            <svg-icon name="cart"></svg-icon>
            <client-only>
              <b v-if="cart.length" class="fs-cartic countTotalCart">
                {{ cart.length }}
              </b>
            </client-only>
          </a>

          <div class="wrap-fill">
            <div class="title">
              <client-only>
                <strong>{{ cart.length }} sản phẩm</strong>
                trong giỏ hàng
              </client-only>
              <a href="javascript:;" class="close">×</a>
            </div>
            <ul>
              <client-only>
                <div v-if="cart.length > 0">
                  <div class="list">
                    <div
                      v-for="productmobile in cart"
                      :key="productmobile.id"
                      class="items"
                    >
                      <div class="ava">
                        <nuxt-link :to="'/' + productmobile.shared_url">
                          <img
                            :src="
                              resizeImage(
                                baseImageUrl + productmobile.thumbnail,
                                60,
                                60
                              )
                            "
                          />
                        </nuxt-link>
                      </div>
                      <div class="content">
                        <h3>
                          <nuxt-link :to="'/' + productmobile.shared_url">
                            {{ productmobile.name }}
                          </nuxt-link>
                        </h3>
                        <span class="prie red">
                          {{
                            (productmobile.sale_price || productmobile.price)
                              | formatNumber
                          }}
                        </span>
                      </div>
                    </div>
                  </div>
                  <div class="btn-bottom">
                    <nuxt-link
                      to="/gio-hang"
                      class="buy btn"
                      @click.native.stop="hideDownCart()"
                    >
                      Giỏ hàng
                    </nuxt-link>
                  </div>
                </div>
                <div v-else class="note">
                  Bạn chưa có sản phẩm nào trong giỏ hàng
                </div>
              </client-only>
            </ul>
          </div>
        </div>
      </div>
    </header>
    <!--HEADER-->
    <header v-if="$device.isDesktopOrTablet" class="fs-header header-pc sticky">
      <div class="f-hdtop">
        <div class="container f-wrap">
          <nuxt-link class="fs-logo" to="/">
            <img src="/css/images/graphics/logo.svg" alt="thinkpro" />
          </nuxt-link>
          <div class="fs-search">
            <div class="action-wrap search" @submit.prevent>
              <input
                ref="input_search"
                v-model="search"
                class="fs-stxt onclick-togle search-input"
                type="text"
                placeholder="Tìm kiếm trên ThinkPro"
                autocomplete="off"
                maxlength="50"
                @keyup.enter.prevent="searchIt"
              />
              <button class="search-button" @click.prevent="searchIt">
                <svg-icon name="search"></svg-icon>
              </button>
            </div>
          </div>
          <ul class="fs-hdmn">
            <li class="lbl-title">
              <nuxt-link to="/tin-tuc">Tin tức</nuxt-link>
            </li>
            <li class="new">
              <nuxt-link to="/thong-bao-thanh-vien">
                <svg-icon name="bel"></svg-icon>
                <span v-if="news.length > 0" class="cart-count">
                  {{ news.length }}
                </span>
              </nuxt-link>
              <div v-if="news.length > 0" class="wrap-fill">
                <ul>
                  <li v-for="_new in news" :key="_new.content">
                    <div class="content">
                      <span class="tag">#Admin</span>
                      <span class="time">{{ _new.send_at }}</span>
                      <p>{{ _new.content }}</p>
                    </div>
                  </li>
                  <li class="list-allview">
                    <nuxt-link to="/thong-bao-thanh-vien" class="view-all">
                      Xem tất cả cập nhật
                      <svg class="icon-svg">
                        <use xlink:href="/images/icons/icon.svg#arrow-right" />
                      </svg>
                    </nuxt-link>
                  </li>
                </ul>
              </div>
            </li>
            <client-only>
              <li class="gio-hang">
                <nuxt-link to="/gio-hang">
                  <svg-icon name="cart"></svg-icon>
                  <span v-if="cart.length" class="cart-count">
                    {{ cart.length }}
                  </span>
                </nuxt-link>
                <client-only>
                  <div class="wrap-fill">
                    <div v-if="cart.length == 0">
                      <ul>
                        <div class="note center">
                          <strong>
                            Bạn chưa có sản phẩm nào trong giỏ hàng
                          </strong>
                        </div>
                      </ul>
                    </div>
                    <div v-else>
                      <ul>
                        <li>
                          <div class="note">
                            <strong>{{ cart.length }} sản phẩm</strong>
                            trong giỏ hàng
                          </div>
                          <div class="list">
                            <div
                              v-for="(product, index) in cart"
                              :key="index"
                              class="items"
                            >
                              <div class="ava">
                                <nuxt-link :to="'/' + product.shared_url">
                                  <img
                                    v-if="product.thumbnail != null"
                                    :src="
                                      resizeImage(
                                        baseImageUrl + product.thumbnail,
                                        56,
                                        56
                                      )
                                    "
                                  />
                                  <img
                                    v-else
                                    src="/images/placeholder/placeholder-small.svg"
                                  />
                                </nuxt-link>
                              </div>
                              <div class="content">
                                <h3>
                                  <nuxt-link :to="'/' + product.shared_url">
                                    {{ product.name }}
                                  </nuxt-link>
                                </h3>
                                <span class="price">
                                  {{
                                    (product.sale_price || product.price)
                                      | formatNumber
                                  }}
                                </span>
                              </div>
                            </div>
                          </div>
                          <div class="btn-bottom">
                            <nuxt-link to="/gio-hang">
                              <strong>Giỏ hàng:</strong>
                              <strong>
                                {{ totalCartMoney | formatNumber }}
                              </strong>
                            </nuxt-link>
                          </div>
                        </li>
                      </ul>
                    </div>
                  </div>
                </client-only>
              </li>
            </client-only>
            <li class="user">
              <a href="javascript:;">
                <svg-icon name="user"></svg-icon>
              </a>
              <div class="wrap-fill">
                <client-only>
                  <ul v-if="$auth.loggedIn">
                    <li>
                      <h3>
                        <nuxt-link to="/tai-khoan">
                          <i class="iconfont-user"></i>
                          Tài khoản
                        </nuxt-link>
                      </h3>
                    </li>
                    <li @click.prevent="logout">
                      <h3>
                        <a href="javascript:;">
                          <i class="iconfont-exit1"></i>
                          Đăng xuất
                        </a>
                      </h3>
                    </li>
                  </ul>
                  <ul v-else>
                    <li>
                      <h3>
                        <a
                          class="login"
                          href="javascript:;"
                          @click.prevent="openLoginPopup('login')"
                        >
                          <i class="iconfont-login"></i>
                          Đăng nhập
                        </a>
                      </h3>
                    </li>
                    <li>
                      <h3>
                        <a
                          class="login"
                          href="javascript:;"
                          @click.prevent="openLoginPopup('register')"
                        >
                          <i class="iconfont-login"></i>
                          Tạo tài khoản
                        </a>
                      </h3>
                    </li>
                  </ul>
                </client-only>
              </div>
            </li>
          </ul>
        </div>
      </div>
    </header>
    <!--END HEADER-->
  </div>
</template>

<script>
import Helper from '../assets/config'
import { EventBus } from '~/plugins/bus'

export default {
  name: 'Header',
  components: {},
  async fetch() {
    const { data } = await this.$axios.$get('/header/news/get')
    this.news = data
  },
  data() {
    return {
      user: {},
      isSticky: false,
      search: '',
      news: [],
      isOpenMegamenu: false,
    }
  },
  computed: {
    cart() {
      return this.$store.state.cart
    },
    totalCartMoney() {
      return this.$store.getters.totalMoney
    },
    baseImageUrl() {
      return Helper.baseImageUrl
    },
  },
  mounted() {
    window.addEventListener('scroll', this.sticky)
  },
  destroyed() {
    this.isSticky = false
  },
  methods: {
    searchIt() {
      this.$router.push('/tim-kiem?search=' + this.search)
    },
    resizeImage(url, width, height) {
      return Helper.resizeImage(url, width, height)
    },
    logout() {
      this.$auth.logout()
    },
    openLoginPopup(type) {
      EventBus.$emit('open-modal-login', true)
      if (type === 'register') {
        EventBus.$emit('type-register', true)
      } else {
        EventBus.$emit('type-register', false)
      }
    },
    sticky() {
      if (window.pageYOffset > 72) {
        this.isSticky = true
      } else {
        this.isSticky = false
      }
    },
    hideDownCart() {
      document.querySelector('body').classList.remove('open-header')
      const cartMobile = document.getElementById('cart-mobile')
      if (cartMobile !== null) {
        cartMobile.classList.remove('active')
      }
    },
  },
}
</script>
